#!/bin/bash
#SBATCH --image=registry.services.nersc.gov/dang/convergence:latest
#SBATCH --volume="/global/cscratch1/sd/dang:/scratch"
#SBATCH --partition=regular
#SBATCH -C haswell
#SBATCH -N 2

n=100
np=64
scriptname=convergence-${np}P-${n}N.sh
outname=convergence-${np}P-${n}N.out
(
cat <<'EOF'
cd /home/idaes/
export PYTHONPATH=`pwd`
export LD_LIBRARY_PATH=/usr/local/lib
. /home/idaes/miniconda3/etc/profile.d/conda.sh
conda activate
cd idaes/models/convergence/pressure_changer
python ../../../core/util/convergence/convergence.py run-eval -np $np -s $n \
 > /scratch/$outname
EOF
) > $SCRATCH/$scriptname
srun -n $np shifter $SCRATCH/$scriptname
