#!/usr/bin/env python
##############################################################################
# Institute for the Design of Advanced Energy Systems Process Systems
# Engineering Framework (IDAES PSE Framework) Copyright (c) 2018, by the
# software owners: The Regents of the University of California, through
# Lawrence Berkeley National Laboratory,  National Technology & Engineering
# Solutions of Sandia, LLC, Carnegie Mellon University, West Virginia
# University Research Corporation, et al. All rights reserved.
# 
# Please see the files COPYRIGHT.txt and LICENSE.txt for full copyright and
# license information, respectively. Both files are also available online
# at the URL "https://github.com/IDAES/idaes".
##############################################################################
"""
Generate an example
"""

from jinja2 import Template
output_files = "/tmp/file{i}.json"
num_to_generate = 10
##############################################################################
# Set dynamic values  for i-th instance
##############################################################################
codetypes = ['method', 'function', 'module',
            'class', 'file', 'package', 'repository']
alltypes = ['propertydb', 'generic', 'notebook']
def modify(v, i):
    # modify dict "v" for i-th
    v['desc'] = 'generated resource #{:d}'.format(i)
    #v['codes'][0]['type'] = codetypes[i % len(codetypes)]
    v['type'] = alltypes[i % len(alltypes)]
    return v
##############################################################################
# Set static values for all instances
##############################################################################
template_vars = {
 'aliases': ['str'],
# 'codes': [{
#     'type': 'str',
#     'desc': 'str',
#     'name': 'str',
#     'language': 'str',
#     'idhash': 'str',
#     'location': 'str',
#     'version': [
#       1,
#       0,
#       0,
#       'str'],
#     }
# ],
 'collaborators': [{
     'email': 'str',
     'name': 'str',
     }
 ],
 'created': 0.0,
 'creator': {
   'email': 'str',
   'name': 'str',
   },
 'data': {},
 'datafiles': [],
# [{
#     'desc': 'str',
#     'metadata': {},
#     'mimetype': 'str',
#     'path': 'str',
#     'subdir': 'str',
#     }
# ],
 'datafiles_dir': '/tmp',
 'desc': 'str',
 'id_': 0,
 'modified': 0.0,
# 'relations': [{
#     'predicate': 'str',
#     'object': 0,
#     }
# ],
 'sources': [{
     'date': 0.0,
     'doi': 'str',
     'isbn': 'str',
     'language': 'str',
     'source': 'str',
     }
 ],
 'tags': ['str'],
 'type': '',
 'version': {
   'created': 0.0,
   'name': 'str',
   'revision': [
     0,
     0,
     0,
     'str'],
   },
}
##############################################################################

#  DO NOT MODIFY BEYOND THIS POINT
##############################################################################
template = Template("""{"aliases": [{%- if aliases is defined and aliases|length > 0 %}"{{ aliases[0] if (aliases and aliases[0]) else "str" }}"{% endif %}], "codes": [{%- if codes is defined and codes|length > 0 %}{"type": "{{ codes[0].type if (codes and codes[0] and codes[0].type) else "str" }}", "desc": "{{ codes[0].desc if (codes and codes[0] and codes[0].desc) else "str" }}", "name": "{{ codes[0].name if (codes and codes[0] and codes[0].name) else "str" }}", "language": "{{ codes[0].language if (codes and codes[0] and codes[0].language) else "str" }}", "idhash": "{{ codes[0].idhash if (codes and codes[0] and codes[0].idhash) else "str" }}", "location": "{{ codes[0].location if (codes and codes[0] and codes[0].location) else "str" }}", "version": [{%- if codes[0].version is defined and codes[0].version|length > 0 %}{{ codes[0].version[0] if (codes and codes[0] and codes[0].version and codes[0].version[0]) else 72 }},{{ codes[0].version[1] if (codes and codes[0] and codes[0].version and codes[0].version[1]) else 37 }},{{ codes[0].version[2] if (codes and codes[0] and codes[0].version and codes[0].version[2]) else 53 }},"{{ codes[0].version[3] if (codes and codes[0] and codes[0].version and codes[0].version[3]) else "str" }}"{% endif %}]}{% endif %}], "collaborators": [{%- if collaborators is defined and collaborators|length > 0 %}{"email": "{{ collaborators[0].email if (collaborators and collaborators[0] and collaborators[0].email) else "str" }}", "name": "{{ collaborators[0].name if (collaborators and collaborators[0] and collaborators[0].name) else "str" }}"}{% endif %}], "created": {{ created if (created) else 0.44 }}, "creator": {"email": "{{ creator.email if (creator and creator.email) else "str" }}", "name": "{{ creator.name if (creator and creator.name) else "str" }}"}, "data": {}, "datafiles": [{%- if datafiles is defined and datafiles|length > 0 %}{"desc": "{{ datafiles[0].desc if (datafiles and datafiles[0] and datafiles[0].desc) else "str" }}", "metadata": {}, "mimetype": "{{ datafiles[0].mimetype if (datafiles and datafiles[0] and datafiles[0].mimetype) else "str" }}", "path": "{{ datafiles[0].path if (datafiles and datafiles[0] and datafiles[0].path) else "str" }}", "subdir": "{{ datafiles[0].subdir if (datafiles and datafiles[0] and datafiles[0].subdir) else "str" }}"}{% endif %}], "datafiles_dir": "{{ datafiles_dir if (datafiles_dir) else "str" }}", "desc": "{{ desc if (desc) else "str" }}", "id_": {{ id_ if (id_) else 27 }}, "modified": {{ modified if (modified) else 0.30 }}, "relations": [{%- if relations is defined and relations|length > 0 %}{"predicate": "{{ relations[0].predicate if (relations and relations[0] and relations[0].predicate) else "str" }}", "object": {{ relations[0].object if (relations and relations[0] and relations[0].object) else 65 }}}{% endif %}], "sources": [{%- if sources is defined and sources|length > 0 %}{"date": {{ sources[0].date if (sources and sources[0] and sources[0].date) else 0.97 }}, "doi": "{{ sources[0].doi if (sources and sources[0] and sources[0].doi) else "str" }}", "isbn": "{{ sources[0].isbn if (sources and sources[0] and sources[0].isbn) else "str" }}", "language": "{{ sources[0].language if (sources and sources[0] and sources[0].language) else "str" }}", "source": "{{ sources[0].source if (sources and sources[0] and sources[0].source) else "str" }}"}{% endif %}], "tags": [{%- if tags is defined and tags|length > 0 %}"{{ tags[0] if (tags and tags[0]) else "str" }}"{% endif %}], "type": "{{ type if (type) else "str" }}", "version": {"created": {{ version.created if (version and version.created) else 0.05 }}, "name": "{{ version.name if (version and version.name) else "str" }}", "revision": [{%- if version.revision is defined and version.revision|length > 0 %}{{ version.revision[0] if (version and version.revision and version.revision[0]) else 33 }},{{ version.revision[1] if (version and version.revision and version.revision[1]) else 80 }},{{ version.revision[2] if (version and version.revision and version.revision[2]) else 24 }},"{{ version.revision[3] if (version and version.revision and version.revision[3]) else "str" }}"{% endif %}]}}""")
##############################################################################
for i in range(num_to_generate):
    cur_vars = modify(template_vars.copy(), i)
    instance = template.render(**cur_vars)
    f = open(output_files.format(i=i), "w")
    f.write(instance)

print("Wrote {n:d} to {p}".format(n=num_to_generate,       p=output_files))
