##############################################################################
# Institute for the Design of Advanced Energy Systems Process Systems
# Engineering Framework (IDAES PSE Framework) Copyright (c) 2018, by the
# software owners: The Regents of the University of California, through
# Lawrence Berkeley National Laboratory,  National Technology & Engineering
# Solutions of Sandia, LLC, Carnegie Mellon University, West Virginia
# University Research Corporation, et al. All rights reserved.
# 
# Please see the files COPYRIGHT.txt and LICENSE.txt for full copyright and
# license information, respectively. Both files are also available online
# at the URL "https://github.com/IDAES/idaes".
##############################################################################
"""
Version numbering for IDAES.

We attempt to follow the guidelines laid out
by the Semantic Versioning effort.

See https://semver.org/ .
"""

#: Major release number
major = 0
#: Minor release number
minor = 1
#: Patchlevel/bugfix release number
patch = 2
#: Pre-release identifiers (may be empty)
prerelease = ('alpha',)
#: Build metadata (may be empty)
build = ()

#: Version information as a tuple
version_info = (major, minor, patch,
                '.'.join(prerelease),
                '.'.join(build))

#: Version information as a string
version = '{ma:d}.{mi:d}.{pa:d}{s1}{pr}{s2}{bu}'.format(
    ma=major, mi=minor, pa=patch,
    s1='-' if prerelease else '',
    pr='.'.join(prerelease),
    s2='+' if build else '',
    bu='.'.join(build))